package org.netkernel.doc.endpoint;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class BookViewWrapper extends StandardAccessorImpl
{
	public BookViewWrapper()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{
		context.setCWU(null);
		String bookid=context.getThisRequest().getArgumentValue("bookid");
		INKFRequest req=context.createRequest("active:bookEntry");
		req.addArgument("id", bookid);
		req.setRepresentationClass(IHDSNode.class);
		IHDSNode book=(IHDSNode)context.issueRequest(req);

		String docid=context.getThisRequest().getArgumentValue("docid");
		if(docid.equals(""))
		{	//Default to the first document in the list
			docid=(String)book.getFirstValue("/book/toc/item[1]/@id");
		}

		//docEntry
		req=context.createRequest("active:documentationEntry");
		req.addArgument("id", docid);
		Object rep=context.issueRequest(req);

		req=context.createRequest("active:docRenderer");
		req.addArgument("bookid", bookid);
		req.addArgument("docid", docid);
		req.addArgumentByValue("docentry", rep);
		context.createResponseFrom(context.issueRequestForResponse(req));

	}
	
	
}
